
; simple vu macros, try not to go overboard!

	.macro	loadMat	name,offset,basereg
	lq			\name[0],\offset(\basereg)
	lq			\name[1],\offset+1(\basereg)
	lq			\name[2],\offset+2(\basereg)
	lq			\name[3],\offset+3(\basereg)
	.endm

	.macro	isetiu	reg,val
	iaddiu	\reg,vi00,\val
	.endm


	.macro	loiMINxy	reg,val0,val1
	loi		\val0
	mini.x		\reg,vf00,i
	loi		\val1
	mini.y		\reg,vf00,i
	.endm


	

	.macro	loiPLUSxy	reg,val0,val1
	loi		\val0
	max.x		\reg,vf00,i
	loi		\val1
	max.y		\reg,vf00,i
	.endm

	.macro	loiPLUSxyzw	reg,val0,val1,val2,val3
	loi		\val0
	max.x		\reg,vf00,i
	loi		\val1
	max.y		\reg,vf00,i
	loi		\val2
	max.z		\reg,vf00,i
	loi		\val3
	max.w		\reg,vf00,i
	.endm

	.macro	loixyz	reg,val0,val1,val2
	loi		\val0
	add.x		\reg,vf00,i
	loi		\val1
	add.y		\reg,vf00,i
	loi		\val2
	add.z		\reg,vf00,i
	.endm

	.macro	loixyzw	reg,val0,val1,val2,val3
	loi		\val0
	add.x		\reg,vf00,i
	loi		\val1
	add.y		\reg,vf00,i
	loi		\val2
	add.z		\reg,vf00,i
	loi		\val3
	mul.w		\reg,vf00,i
	.endm






	.macro	mulMat	out,inL,inR
	
	mul	acc,\inR[0],\inL[0][x]
	madd	acc,\inR[1],\inL[0][y]
	madd	acc,\inR[2],\inL[0][z]
	madd	\out[0],\inR[3],\inL[0][w]

	mul	acc,\inR[0],\inL[1][x]
	madd	acc,\inR[1],\inL[1][y]
	madd	acc,\inR[2],\inL[1][z]
	madd	\out[1],\inR[3],\inL[1][w]
	
	mul	acc,\inR[0],\inL[2][x]
	madd	acc,\inR[1],\inL[2][y]
	madd	acc,\inR[2],\inL[2][z]
	madd	\out[2],\inR[3],\inL[2][w]
	
	mul	acc,\inR[0],\inL[3][x]
	madd	acc,\inR[1],\inL[3][y]
	madd	acc,\inR[2],\inL[3][z]
	madd	\out[3],\inR[3],\inL[3][w]
	
	.endm

	; normalise a vector in a register
	; ok for in-place
	; uses  ACC

	.macro	normalise_qx	norm,vec
	mul.xyz	tmp,\vec,\vec
	adda.x	acc,tmp,tmp[y]
	madd.x	tmp,ONE,tmp[z]
	rsqrt		q,vf00[w],tmp[x]
	mulq.xyz	\norm,\vec,q   		; norm is normal in dof
	.endm


	.macro	normalise_p		norm,vec
	erleng 	p,\vec
	mfp.w		tmp,p
	mulw.xyz	\norm,\vec,tmp[w]   		; norm is normal in dof
	.endm
	

	.macro	cross	out,l,r
	opmula.xyz	acc,\l,\r
	opmsub.xyz	\out,\r,\l
	.endm



